<template>
  <a-card
    :bordered="false"
    title=""
  >
    <!-- table区域-begin -->
    <div>
      <!-- <div
        class="ant-alert ant-alert-info"
        style="margin-bottom: 16px;"
      >
        <i class="anticon anticon-info-circle ant-alert-icon"></i> 已选择 <a style="font-weight: 600">{{ selectedRowKeys.length }}</a>项
        <a
          style="margin-left: 24px"
          @click="onClearSelected"
        >清空</a>
      </div> -->

      <a-table
        ref="table"
        size="middle"
        :scroll="{ x: 'calc(2800px + 50%)', y: 900 }"
        bordered
        rowKey="id"
        :columns="columns"
        :dataSource="dataSource"
        :pagination="ipagination"
        :loading="loading"
        class="j-table-force-nowrap"
        @change="handleTableChange"
        :rowSelection="rowSelection"
        :rowClassName="tableRowClass"
      >

        <span
          slot="action"
          slot-scope="text, record"
        >
          <a-popconfirm
            title="确定接收工单吗?"
            @confirm="() => handleOrderIssue(record)"
            v-has="'dailyMaintenanceOrder:issue'"
          >
            <a v-show="record.status == '1'">接收</a>
          </a-popconfirm>
          <a-divider
            v-show="record.status == '1'"
            type="vertical"
          />
          <a-popconfirm
            title="确定撤回工单吗?"
            @confirm="() => handleOrderReset(record)"
            v-has="'dailyMaintenanceOrder:issue'"
          >
            <a v-show="record.status == '2'">撤回</a>
          </a-popconfirm>
          <a-divider
            v-show="record.status == '2'"
            type="vertical"
          />
          <a-divider
            v-show="record.status == '2'"
            type="vertical"
          />
          <a-popconfirm
            title="确定领取工单吗?"
            @confirm="() => handleOrderGet(record)"
            v-has="'dailyMaintenanceOrder:get'"
          >
            <a v-show="record.status == '2' && record.assignMode == '1'">领取</a>
          </a-popconfirm>
          <!-- <a
            v-show="record.status == '2' && record.assignMode == '2'  "
            @click="handleAssignOrder(record)"
            v-has="'dailyMaintenanceOrder:assign'"
          >派工</a>

          <a-divider
            v-show="record.status == '2'"
            type="vertical"
          /> -->
          <a-divider
            v-show="record.status === '3'&& record.assignMode == '2'  && record.maintenanceUserName != null  "
            type="vertical"
          />
          <a
            v-show="record.status === '3' || record.status === '4'  "
            @click="handleOrderExe(record)"
            v-has="'dailyMaintenanceOrder:exe'"
          >执行</a>
          <a-divider
            v-show="record.status === '3' || record.status === '4' "
            type="vertical"
          />
          <a
            v-show="record.status === '1'"
            @click="handleEdit(record)"
            v-has="'dailyMaintenanceOrder:edit'"
          >编辑</a>
          <a-divider
            v-show="record.status === '1'"
            type="vertical"
          />
          <a
            v-show="(record.status === '5' || record.status === '8') && (record.confirmStatus === '0' || record.confirmStatus === '2')"
            @click="handleFinish(record)"
            v-has="'dailyMaintenanceOrder:operateUser'"
          >完工移交单</a>
          <a
            v-show="(record.status === '5' || record.status === '8') && (record.confirmStatus === '1' || record.confirmStatus === '4')"
            @click="handleFinish(record)"
            v-has="'dailyMaintenanceOrder:repairUser'"
          >完工移交单</a>
          <a
            v-show="(record.status === '5' || record.status === '8') && (record.confirmStatus === '3' || record.confirmStatus === '6')"
            @click="handleFinish(record)"
            v-has="'dailyMaintenanceOrder:repairDirectorUser'"
          >完工移交单</a>
          <a
            v-show="(record.status === '5' || record.status === '8') && (record.confirmStatus === '5')"
            @click="handleFinish(record)"
            v-has="'dailyMaintenanceOrder:equipmentInspectorUser'"
          >完工移交单</a>
          <a
            v-show="(record.status === '5' || record.status === '8') && (record.confirmStatus === '7')"
            @click="handleFinish(record)"
          >完工移交单</a>
          <a-divider
            v-show="record.status === '5' || record.status === '8'"
            type="vertical"
          />
          <a-dropdown>
            <a class="ant-dropdown-link">更多 <a-icon type="down" /></a>
            <a-menu slot="overlay">
              <a-menu-item>
                <a @click="handleDetail(record)">详情</a>
              </a-menu-item>
              <a-menu-item>
                <a-popconfirm
                  title="确定删除吗?"
                  @confirm="() => handleDelete(record.id)"
                  v-has="'dailyMaintenanceOrder:delete'"
                >
                  <a v-show="record.status === '1'">删除</a>
                </a-popconfirm>
              </a-menu-item>
            </a-menu>
          </a-dropdown>
        </span>

        <span
          slot="num"
          slot-scope="text, record"
        >
          <a
            v-if="record.status === '3' || record.status === '4' ||record.status === '5'  ||record.status === '7' ||record.status === '8'"
            class="lot"
            @click="handleOrderExe(record)"
          >{{record.num}}</a>
          <span v-else>{{record.num}}</span>
        </span>

      </a-table>
    </div>

    <maintenance-order-modal
      ref="modalForm"
      @ok="modalFormOk"
    ></maintenance-order-modal>
    <finish-devolution-modal
      ref="FinishDevolutionModal"
      @ok="modalFormOk"
    ></finish-devolution-modal>
    <maintenance-order-assign-modal
      ref="MaintenanceOrderAssignModal"
      @ok="modalFormOk"
    ></maintenance-order-assign-modal>
    <daily-maintenance-order-exe-drawer
      ref="DailyMaintenanceOrderExeDrawer"
      @ok="modalFormOk"
    ></daily-maintenance-order-exe-drawer>
  </a-card>
</template>

<script>

import '@/assets/less/TableExpand.less'
import { mixinDevice } from '@/utils/mixin'
import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import MaintenanceOrderModal from '@/views/eam/modules/dailyMaintenanceOrder/MaintenanceOrderModal'
import FinishDevolutionModal from '@/views/eam/modules/dailyMaintenanceOrder/FinishDevolutionModal'
import MaintenanceOrderAssignModal from '@/views/eam/modules/dailyMaintenanceOrder/MaintenanceOrderAssignModal'
import DailyMaintenanceOrderExeDrawer from '@/views/eam/modules/dailyMaintenanceOrder/DailyMaintenanceOrderExeDrawer'
import { getAction, postAction, requestPut } from '@/api/manage'

export default {
  name: 'DailyMaintenanceOrderList',
  mixins: [JeecgListMixin, mixinDevice],
  components: {
    MaintenanceOrderModal,
    FinishDevolutionModal,
    MaintenanceOrderAssignModal,
    DailyMaintenanceOrderExeDrawer
  },
  props:{
    mainId:{
      type:String,
      default:'',
      required:false
    }
  },
  watch:{
    mainId:{
      immediate: true,
      handler(val) {
        if(!this.mainId){
          this.queryParam['equipmentId'] = 'NAN'
          this.loadData(1);
        }else{
          this.queryParam['equipmentId'] = val
          this.queryParam['statusEnums'] = '6,7,8,9'
          this.loadData(1);
        }
      }
    }
  },
  data() {
    return {
      description: '二级保养工单',
      queryParam: { maintenanceType: '2' },
      finishTime: [],
      // 表头
      columns: [
        {
          title: '#',
          dataIndex: '',
          key: 'rowIndex',
          width: 60,
          align: "center",
          customRender: function (t, r, index) {
            return parseInt(index) + 1;
          }
        },
        {
          title: '保养工单号',
          align: "center",
          dataIndex: 'num',
          scopedSlots: { customRender: 'num' }
        },
        {
          title: '统一编码',
          align: "center",
          dataIndex: 'equipmentNum',
        },
        {
          title: '状态',
          align: "center",
          width: 100,
          dataIndex: 'statusName'
        },
        // {
        //   title: '保养类型',
        //   align: "center",
        //   dataIndex: 'maintenanceTypeName',
        // },
        // {
        //   title: '保养周期',
        //   align: "center",
        //   dataIndex: 'maintenanceCycleName',
        // },
        // {
        //   title: '派工方式',
        //   align: "center",
        //   dataIndex: 'assignModeName',
        //   width: 100,
        // },
        {
          title: '移交单确认状态',
          align: "center",
          dataIndex: 'confirmStatusName'
        },

        {
          title: '设备名称',
          align: "center",
          dataIndex: 'equipmentName',
        },
        {
          title: '型号',
          align: "center",
          dataIndex: 'equipmentModel',
        },
        // {
        //   title: '保养标准编码',
        //   align: "center",
        //   dataIndex: 'maintenanceStandardNum',
        // },

        {
          title: '使用部门',
          align: "center",
          dataIndex: 'departName'
        },
        {
          title: '责任班组',
          align: "center",
          dataIndex: 'teamName'
        },
        // {
        //   title: '工时定额',
        //   align: "center",
        //   dataIndex: 'workingHourQuota'
        // },
        // {
        //   title: '计划开始时间',
        //   align: "center",
        //   dataIndex: 'planStartTime',
        //   //width: '120px',
        // },
        // {
        //   title: '计划结束时间',
        //   align: "center",
        //   dataIndex: 'planEndTime',
        //   //width: '120px',
        // },
        {
          title: '执行时间',
          align: "center",
          dataIndex: 'actualStartTime',
          //width: '120px',
        },
        {
          title: '完工时间',
          align: "center",
          dataIndex: 'actualEndTime',
          //width: '120px',
        },
        // {
        //   title: '实际用时',
        //   align: "center",
        //   dataIndex: 'actualWorkingHourQuota',
        // },
        // {
        //   title: '报工人',
        //   align: "center",
        //   dataIndex: 'maintenanceUserId'
        // },
        {
          title: '问题及相应处理措施描述',
          align: "center",
          dataIndex: 'description'
        },
        {
          title: '创建人',
          align: "center",
          dataIndex: 'createBy'
        },
        {
          title: '创建日期',
          align: "center",
          dataIndex: 'createTime',
          //width: '120px',
        },
        {
          title: '操作',
          dataIndex: 'action',
          align: "center",
          fixed: "right",
          width: 300,
          scopedSlots: { customRender: 'action' }
        }
      ],
      url: {
        list: "/eam/dailyMaintenanceOrder/getDailyMaintenanceOrderList",
        delete: "/eam/dailyMaintenanceOrder/delete",
        deleteBatch: "/eam/dailyMaintenanceOrder/deleteBatch",
        exportXlsUrl: "/eam/dailyMaintenanceOrder/exportXls",
        importExcelUrl: "eam/dailyMaintenanceOrder/importExcel",
        edit: "/eam/dailyMaintenanceOrder/editStatus",
        orderGet: "/eam/dailyMaintenanceOrder/orderGet",
      },
    }
  },

  computed: {
    importExcelUrl: function () {
      return `${window._CONFIG['domianURL']}/${this.url.importExcelUrl}`;
    },
    rowSelection() {
      return {
        type: 'checkbox',
        onChange: (selectedRowKeys, selectedRows) => {
          this.selectedRowKeys = selectedRowKeys;
          this.onSelectChange(selectedRows);
        },
        getCheckboxProps: record => ({
          props: {
            disabled: record.distable
          },
        }),
        selectedRowKeys: this.selectedRowKeys,
      };
    },
  },

  methods: {

    onSelectChange(selectionRows) {
      this.selectionRows = selectionRows;
    },

    handleOrderExe(record) {
      this.$refs.DailyMaintenanceOrderExeDrawer.visible = true
      this.$refs.DailyMaintenanceOrderExeDrawer.title = '二级保养工单执行'
      this.$refs.DailyMaintenanceOrderExeDrawer.handleShow(record)
      if (record.status === '3') {
        this.$refs.DailyMaintenanceOrderExeDrawer.buttonDistable = true//保存、暂存、报工
        this.$refs.DailyMaintenanceOrderExeDrawer.revocationDistable = true//撤销按钮
        this.$refs.DailyMaintenanceOrderExeDrawer.SWbuttonDistable = false//开工按钮
      } else if (record.status === '4') {
        this.$refs.DailyMaintenanceOrderExeDrawer.buttonDistable = false
        this.$refs.DailyMaintenanceOrderExeDrawer.revocationDistable = true
        this.$refs.DailyMaintenanceOrderExeDrawer.SWbuttonDistable = true
      } else if (record.status === '5') {
        this.$refs.DailyMaintenanceOrderExeDrawer.buttonDistable = true
        this.$refs.DailyMaintenanceOrderExeDrawer.revocationDistable = false
        this.$refs.DailyMaintenanceOrderExeDrawer.SWbuttonDistable = true
      } else if (record.status === '7') {
        this.$refs.DailyMaintenanceOrderExeDrawer.buttonDistable = true
        this.$refs.DailyMaintenanceOrderExeDrawer.revocationDistable = true
        this.$refs.DailyMaintenanceOrderExeDrawer.SWbuttonDistable = true
      }
    },

    handleFinish: function (record) {
      this.$refs.FinishDevolutionModal.edit(record);
      this.$refs.FinishDevolutionModal.title = "生产设备二级保养完工移交单";
      this.$refs.FinishDevolutionModal.disableSubmit = false;
    },

    handleOrderIssue(record) {
      const that = this;
      requestPut(that.url.edit, { id: record.id, status: '2' }).then((res) => {
        if (res.success) {
          that.$message.success("工单下发成功！")
          that.loadData()
        } else {
          that.$message.warning("工单下发失败！")
        }
      })
    },
    //撤回
    handleOrderReset(record) {
      const that = this;
      requestPut(that.url.edit, { id: record.id, status: '1' }).then((res) => {
        if (res.success) {
          that.$message.success("工单撤回成功！")
          that.loadData()
        } else {
          that.$message.warning("工单撤回失败！")
        }
      })
    },
    handleOrderGet(record) {
      const that = this;
      requestPut(that.url.orderGet, { id: record.id, status: '1' }).then((res) => {
        if (res.success) {
          that.$message.success("工单领取成功！")
          that.loadData()
        } else {
          that.$message.warning("工单领取失败！")
        }
      })
    },

    //预警颜色
    tableRowClass(record, index) {
      if ("1" == record.status || "2" == record.status) {
        if (record.yellowWarningTime < record.currentDateTime && record.currentDateTime < record.redWarningTime) {
          return 'yellow'
        } else if (record.redWarningTime < record.currentDateTime && record.currentDateTime < record.planStartTime) {
          return 'error'
        } else if (record.planStartTime < record.currentDateTime) {
          return 'frozenRowClass'
        }
      }
    },
  }
}
</script>
<style >
@import '~@assets/less/common.less';
.frozenRowClass {
  color: #c9c9c9;
  font-weight: bold;
}
.success {
  color: green;
}
.error {
  color: red;
  font-weight: bold;
}
.yellow {
  color: rgba(255, 255, 0, 0.443);
  font-weight: bold;
}
.fontweight {
  font-weight: bold;
}

.ant-table-tbody .red {
  background-color: red !important;
}
</style>